test_cases:

  - user_agent_string: 'Mozilla/5.0 (Linux x86_64) AppleWebKit/534.26+ WebKitGTK+/1.4.1 luakit/f3a2dbe'
    family: 'Linux'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; Linux x86_64; rv:2.0) Gecko/20110408 conkeror/0.9.3'
    family: 'Linux'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.1.16) Gecko/20110302 Conkeror/0.9.2 (Debian-0.9.2+git100804-1)'
    family: 'Debian'
    major: '0'
    minor: '9'
    patch: '2'
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.17) Gecko/20110414 Lightning/1.0b3pre Thunderbird/3.1.10'
    family: 'Windows XP'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.2.17) Gecko/20110414 Thunderbird/3.1.10 ThunderBrowse/3.3.5'
    family: 'Windows 7'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Windows; U; en-US) AppleWebKit/531.9 (KHTML, like Gecko) AdobeAIR/2.5.1'
    family: 'Windows'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)'
    family: 'Other'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 YottaaMonitor;'
    family: 'Other'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/534.3 (KHTML, like Gecko) RockMelt/0.8.34.841 Chrome/6.0.472.63 Safari/534.3'
    family: 'Windows XP'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; Linux x86_64; rv:2.0) Gecko/20110417 IceCat/4.0'
    family: 'Linux'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux i686; nl-NL) AppleWebKit/534.3 (KHTML, like Gecko) WeTab-Browser Safari/534.3'
    family: 'WeTab'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/4.0 (compatible; Linux 2.6.10) NetFront/3.3 Kindle/1.0 (screen 600x800)'
    family: 'Kindle'
    major: '1'
    minor: '0'
    patch:
    patch_minor:

  - user_agent_string: 'Opera/9.80 (Android 3.2; Linux; Opera Tablet/ADR-1106291546; U; en) Presto/2.8.149 Version/11.10'
    family: 'Android'
    major: '3'
    minor: '2'
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) FireWeb/1.0.0.0'
    family: 'Windows 7'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/532.5 (KHTML, like Gecko) Comodo_Dragon/4.1.1.11 Chrome/4.1.249.1042 Safari/532.5'
    family: 'Windows XP'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (iPod; U; CPU iPhone OS 4_3_2 like Mac OS X; en-us) AppleWebKit/533.17.9 (KHTML, like Gecko) Version/5.0.2 Mobile/8H7 Safari/6533.18.5'
    family: 'iOS'
    major: '4'
    minor: '3'
    patch: '2'
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Linux; U; Android 3.0.1; en-us; GT-P7510 Build/HRI83) AppleWebKit/534.13 (KHTML, like Gecko) Version/4.0 Safari/534.13'
    family: 'Android'
    major: '3'
    minor: '0'
    patch: '1'
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (hp-tablet; Linux; hpwOS/3.0.0; U; en-US) AppleWebKit/534.6 (KHTML, like Gecko) wOSBrowser/233.58 Safari/534.6 TouchPad/1.0'
    family: 'webOS'
    major: '3'
    minor: '0'
    patch: '0'
    patch_minor:

  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 7.0; Windows Phone OS 7.0; Trident/3.1; IEMobile/7.0; SAMSUNG; SGH-i917)'
    family: 'Windows Phone OS'
    major: '7'
    minor: '0'
    patch:
    patch_minor:


  - user_agent_string: 'Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_5_7; en-us) AppleWebKit/530.17 (KHTML, like Gecko) Version/4.0 Safari/530.17 Skyfire/2.0'
    family: 'Mac OS X'
    major: '10'
    minor: '5'
    patch: '7'
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (PlayBook; U; RIM Tablet OS 1.0.0; en-US) AppleWebKit/534.8+ (KHTML, like Gecko) Version/0.0.1 Safari/534.8+'
    family: 'BlackBerry Tablet OS'
    major: '1'
    minor: '0'
    patch: '0'
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux i686; en-US) AppleWebKit/534.16 (KHTML, like Gecko) Ubuntu/10.10 Chromium/10.0.648.133 Chrome/10.0.648.133 Safari/534.16'
    family: 'Ubuntu'
    major: '10'
    minor: '10'
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Windows NT 5.1; rv:2.0) Gecko/20110407 Firefox/4.0.3 PaleMoon/4.0.3'
    family: 'Windows XP'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Opera/9.80 (Series 60; Opera Mini/6.24455/25.677; U; fr) Presto/2.5.25 Version/10.54'
    family: 'Symbian OS'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; Linux i686 (x86_64); rv:2.0b4) Gecko/20100818 Firefox/4.0b4'
    family: 'Linux'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9.2.12) Gecko/20101027 Ubuntu/10.04 (lucid) Firefox/3.6.12'
    family: 'Ubuntu'
    major: '10'
    minor: '04'
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.1.1pre) Gecko/20090717 Ubuntu/9.04 (jaunty) Shiretoko/3.5.1pre'
    family: 'Ubuntu'
    major: '9'
    minor: '04'
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; Linux x86_64; rv:2.0b8pre) Gecko/20101031 Firefox-4.0/4.0b8pre'
    family: 'Linux'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; U; BSD Four; en-US) AppleWebKit/533.3 (KHTML, like Gecko) rekonq Safari/533.3'
    family: 'BSD'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux; de-DE) AppleWebKit/527  (KHTML, like Gecko, Safari/419.3) konqueror/4.3.1'
    family: 'Linux'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'SomethingWeNeverKnewExisted'
    family: 'Other'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Midori/0.2 (X11; Linux; U; en-us) WebKit/531.2 '
    family: 'Linux'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.3a1) Gecko/20100208 MozillaDeveloperPreview/3.7a1 (.NET CLR 3.5.30729)'
    family: 'Windows 7'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Opera/9.80 (Windows NT 5.1; U; ru) Presto/2.5.24 Version/10.53'
    family: 'Windows XP'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Opera/9.80 (S60; SymbOS; Opera Mobi/275; U; es-ES) Presto/2.4.13 Version/10.00'
    family: 'Symbian OS'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (webOS/1.2; U; en-US) AppleWebKit/525.27.1 (KHTML, like Gecko) Version/1.0 Safari/525.27.1 Desktop/1.0'
    family: 'webOS'
    major: '1'
    minor: '2'
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (iPad; U; CPU OS 3_2 like Mac OS X; en-us) AppleWebKit/531.21.10 (KHTML, like Gecko) Version/4.0.4 Mobile/7B367 Safari/531.21.10'
    family: 'iOS'
    major: '3'
    minor: '2'
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (SAMSUNG; SAMSUNG-GT-S8500/S8500XXJEE; U; Bada/1.0; nl-nl) AppleWebKit/533.1 (KHTML, like Gecko) Dolfin/2.0 Mobile WVGA SMM-MMS/1.2.0 OPN-B'
    family: 'Bada'
    major: '1'
    minor: '0'
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; BOLT/2.101) AppleWebKit/530  (KHTML, like Gecko) Version/4.0 Safari/530.17'
    family: 'Windows XP'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Macintosh; U; PPC Mac OS X; en-us) AppleWebKit/418.8 (KHTML, like Gecko) Safari/419.3'
    family: 'Mac OS X'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_6_5; en-us) AppleWebKit/533.18.1 (KHTML, like Gecko) Version/5.0.2 Safari/533.18.5'
    family: 'Mac OS X'
    major: '10'
    minor: '6'
    patch: '5'
    patch_minor:

  # BlackBerry devices
  - user_agent_string: 'Mozilla/5.0 (BlackBerry; U; BlackBerry 9800; en-GB) AppleWebKit/534.1+ (KHTML, like Gecko) Version/6.0.0.141 Mobile Safari/534.1+'
    family: 'BlackBerry OS'
    major: '6'
    minor: '0'
    patch: '0'
    patch_minor: '141'

  - user_agent_string: 'Mozilla/5.0 (BlackBerry; U; BlackBerry 9800; en-US) AppleWebKit/534.1  (KHTML, like Gecko) Version/6.0.0.91 Mobile Safari/534.1 '
    family: 'BlackBerry OS'
    major: '6'
    minor: '0'
    patch: '0'
    patch_minor: '91'

  # Chrome
  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; chromeframe; .NET CLR 2.0.50727; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729; Sleipnir 2.8.5)3.0.30729)'
    js_ua: "{'js_user_agent_string': 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/530.1 (KHTML, like Gecko) Chrome/2.0.169.1 Safari/530.1'}"
    family: 'Windows XP'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0; Trident/4.0; chromeframe; SLCC1; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729)'
    js_ua: "{'js_user_agent_string': 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/530.1 (KHTML, like Gecko) Chrome/2.0.169.1 Safari/530.1'}"
    family: 'Windows Vista'
    major:
    minor:
    patch:
    patch_minor:

  # Chrome Frame installed but not enabled
  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; GTB6; chromeframe; .NET CLR 2.0.50727; .NET CLR 1.1.4322; .NET CLR 3.0.04506.648; .NET CLR 3.5.21022; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)'
    js_ua: "{'js_user_agent_string': 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; chromeframe; .NET CLR 2.0.50727; .NET CLR 1.1.4322; .NET CLR 3.0.04506.648; .NET CLR 3.5.21022; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)'}"
    family: 'Windows XP'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; GTB6; .NET CLR 2.0.50727; .NET CLR 1.1.4322)'
    js_ua: "{'js_user_agent_string': 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; .NET CLR 2.0.50727; .NET CLR 1.1.4322)', 'js_user_agent_family': 'IE Platform Preview', 'js_user_agent_v1': '9', 'js_user_agent_v2': '0', 'js_user_agent_v3': '1'}"
    family: 'Windows XP'
    major:
    minor:
    patch:
    patch_minor:

  # version indeterminate. could also be windows phone 7.5
  - user_agent_string: 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; Trident/5.0; XBLWP7; ZuneWP7)'
    family: 'Windows Phone OS'
    major:
    minor:
    patch:
    patch_minor:

  - user_agent_string: 'python-requests/0.14 CPython/2.6 Linux/2.6-43-server'
    family: 'Linux'
    major: '2'
    minor: '6'
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; ARM; Trident/6.0)'
    family: 'Windows RT'
    major:
    minor: 
    patch:
    patch_minor:

  - user_agent_string: 'Mozilla/5.0 (BB10; Touch) AppleWebKit/537.3+ (KHTML, like Gecko) Version/10.0.9.388 Mobile Safari/537.3+'
    family: 'BlackBerry OS'
    major: '10'
    minor: '0'
    patch: '9'
    patch_minor: 